require "fnordmetric"

FnordMetric.namespace :gihyo do
  gauge :lokka_access, title: "Access", tick: 10.second.to_i
  gauge :lokka_flyweight, title: "Super Fast Access", tick: 10.second.to_i
  gauge :lokka_fast     , title: "Fast Access", tick: 10.second.to_i
  gauge :lokka_middle   , title: "Normal Access", tick: 10.second.to_i
  gauge :lokka_slow     , title: "Slow Access", tick: 10.second.to_i

  event "metric.all_access" do
    set_value :lokka_access, data[:info][:all_count].to_i
  end

  event "metric.elapsed_msec" do
    set_value :lokka_flyweight, data[:info][:flyweight_percentage].to_f
    set_value :lokka_fast, data[:info][:fast_percentage].to_f
    set_value :lokka_middle, data[:info][:middle_percentage].to_f
    set_value :lokka_slow, data[:info][:slow_percentage].to_f
  end

  widget "All Access", {
    title: "All Access",
    type:  :timeline,
    width: 100,
    gauges: [:lokka_access],
    include_current: true,
    auto_update: 10.second.to_i
  }

  widget "Elapsed Time", {
    title: "Elapsed Time",
    type:  :timeline,
    width: 100,
    gauges: [:lokka_flyweight, :lokka_fast, :lokka_middle, :lokka_slow],
    include_current: true,
    auto_update: 10.second.to_i
  }
end

FnordMetric::Web.new(:port => 4242)
FnordMetric::Worker.new
FnordMetric.run
