require 'fluent-logger'
class Lokka::AccessTracker
  include Fluent::Logger
  def initialize(app, *fluent_conf)
    @app = app
    @logger = FluentLogger.new('lokka', *fluent_conf)
  end
  attr_reader :app, :logger

  ASSETS_RE = /\.(jpg|png|gif|ico|css|js)$/

  def call(env)
    start = Time.now
    code, body, headers = *app.call(env)
    elapsed = (Time.now - start) * 1000
    req = Rack::Request.new(env)
    if req.path !~ ASSETS_RE
      info = {
        path: req.path,
        status: code,
        referer: req.referer,
        elapsed_msec: elapsed.to_i,
      }.merge(env['lokka.tracker'] || {})
      logger.post('tracker', info)
    end
    return code, body, headers
  end
end
